| Flutter Impeller |

Namespaces | Classes | Typedefs | Enumerations | Functions
impeller::android Namespace Reference

## Namespaces
| testing

## Classes
struct | AndroidProc
class | Choreographer
| This class describes access to the choreographer instance for the current thread. Choreographers are only available on API levels above 24. On levels below 24, an invalid choreographer will be returned. More...
class | HardwareBuffer
| A wrapper for AHardwareBuffer https://developer.android.com/ndk/reference/group/a-hardware-buffer. More...
struct | HardwareBufferDescriptor
| A descriptor use to specify hardware buffer allocations. More...
class | NativeWindow
| A wrapper for ANativeWindow https://developer.android.com/ndk/reference/group/a-native-window. More...
struct | ProcTable
| The table of Android procs that are resolved dynamically. More...
class | SurfaceControl
| A wrapper for ASurfaceControl. https://developer.android.com/ndk/reference/group/native-activity#asurfacecontrol. More...
class | SurfaceTransaction
| A wrapper for ASurfaceTransaction. https://developer.android.com/ndk/reference/group/native-activity#asurfacetransaction. More...
struct | TransactionInFlightData

## Typedefs
using | HardwareBufferUsage = uint8_t

## Enumerations
enum | HardwareBufferFormat { HardwareBufferFormat::kR8G8B8A8UNormInt }
enum | HardwareBufferUsageFlags : HardwareBufferUsage { HardwareBufferUsageFlags::kFrameBufferAttachment = 1u << 0u, HardwareBufferUsageFlags::kCompositorOverlay = 1u << 1u, HardwareBufferUsageFlags::kSampledImage = 1u << 2u }

## Functions
static Choreographer::FrameTimePoint | ClockMonotonicNanosToFrameTimePoint (int64_t p_nanos)
static AHardwareBuffer_Format | ToAHardwareBufferFormat (HardwareBufferFormat format)
static AHardwareBuffer_Desc | ToAHardwareBufferDesc (const HardwareBufferDescriptor &desc)
const ProcTable & | GetProcTable ()
ProcTable & | GetMutableProcTable ()
template<class T >
void | ResolveAndroidProc (AndroidProc< T > &proc, const std::vector< fml::RefPtr< fml::NativeLibrary >> &libs)

## Typedef Documentation

## ◆ HardwareBufferUsage

using impeller::android::HardwareBufferUsage = typedef uint8_t

Definition at line 29 of file hardware_buffer.h.

## Enumeration Type Documentation

## ◆ HardwareBufferFormat

enum impeller::android::HardwareBufferFormat
| strong

Enumerator
kR8G8B8A8UNormInt | This format is guaranteed to be supported on all versions of Android. This format can also be converted to an Impeller and Vulkan format. See also Vulkan Format: VK_FORMAT_R8G8B8A8_UNORM OpenGL ES Format: GL_RGBA8 Why have many format when one format do trick?

Definition at line 16 of file hardware_buffer.h.

16 {
17 //----------------------------------------------------------------------------
18 /// This format is guaranteed to be supported on all versions of Android. This
19 /// format can also be converted to an Impeller and Vulkan format.
20 ///
21 /// @see Vulkan Format: VK_FORMAT_R8G8B8A8_UNORM
22 /// @see OpenGL ES Format: GL_RGBA8
23 ///
24 /// Why have many format when one format do trick?
25 ///
26 kR8G8B8A8UNormInt,
27 };

## ◆ HardwareBufferUsageFlags

enum impeller::android::HardwareBufferUsageFlags : HardwareBufferUsage
| strong

Enumerator
kFrameBufferAttachment |
kCompositorOverlay |
kSampledImage |

Definition at line 31 of file hardware_buffer.h.

31 : HardwareBufferUsage {
32 kFrameBufferAttachment = 1u << 0u,
33 kCompositorOverlay = 1u << 1u,
34 kSampledImage = 1u << 2u,
35 };

## Function Documentation

## ◆ ClockMonotonicNanosToFrameTimePoint()

static Choreographer::FrameTimePoint impeller::android::ClockMonotonicNanosToFrameTimePoint | ( | int64_t | p_nanos | ) |
| static

Definition at line 33 of file choreographer.cc.

34 {
35 return Choreographer::FrameTimePoint{std::chrono::nanoseconds(p_nanos)};
36 }

Referenced by impeller::android::Choreographer::PostFrameCallback().

## ◆ GetMutableProcTable()

ProcTable& impeller::android::GetMutableProcTable | ( |  | ) |

Definition at line 18 of file proc_table.cc.

18 {
19 return const_cast<ProcTable&>(GetProcTable());
20 }

References GetProcTable().

## ◆ GetProcTable()

const ProcTable & impeller::android::GetProcTable | ( |  | ) |

Definition at line 12 of file proc_table.cc.

12 {
13 static ProcTable gProcTable;
14 return gProcTable;
15 }

Referenced by impeller::android::SurfaceTransaction::Apply(), impeller::android::HardwareBuffer::Describe(), GetMutableProcTable(), impeller::android::HardwareBuffer::GetSystemUniqueID(), impeller::android::HardwareBuffer::HardwareBuffer(), impeller::android::HardwareBufferDescriptor::IsAllocatable(), impeller::android::Choreographer::IsAvailableOnPlatform(), impeller::android::SurfaceControl::IsAvailableOnPlatform(), impeller::android::SurfaceTransaction::IsAvailableOnPlatform(), impeller::android::HardwareBuffer::IsAvailableOnPlatform(), impeller::android::NativeWindow::NativeWindow(), impeller::android::Choreographer::PostFrameCallback(), impeller::android::SurfaceTransaction::SetBackgroundColor(), impeller::android::SurfaceTransaction::SetContents(), impeller::android::SurfaceTransaction::SetParent(), impeller::android::SurfaceControl::SurfaceControl(), and impeller::android::testing::TEST().

## ◆ ResolveAndroidProc()

template<class T >

void impeller::android::ResolveAndroidProc | ( | AndroidProc< T > & | proc,
|  | const std::vector< fml::RefPtr< fml::NativeLibrary >> & | libs
| ) |  |

Definition at line 23 of file proc_table.cc.

25 {
26 for (const auto& lib : libs) {
27 proc.proc = lib->ResolveFunction<T*>(proc.proc_name).value_or(nullptr);
28 if (proc.proc) {
29 break;
30 }
31 }
32 }

References impeller::android::AndroidProc< T >::proc, and impeller::android::AndroidProc< T >::proc_name.

## ◆ ToAHardwareBufferDesc()

static AHardwareBuffer_Desc impeller::android::ToAHardwareBufferDesc | ( | const HardwareBufferDescriptor & | desc | ) |
| static

Definition at line 20 of file hardware_buffer.cc.

21 {
22 AHardwareBuffer_Desc ahb_desc = {};
23 ahb_desc.width = desc.size.width;
24 ahb_desc.height = desc.size.height;
25 ahb_desc.format = ToAHardwareBufferFormat(desc.format);
26 ahb_desc.layers = 1u;
27 if (desc.usage & static_cast<HardwareBufferUsage>(
28 HardwareBufferUsageFlags::kFrameBufferAttachment)) {
29 ahb_desc.usage |= AHARDWAREBUFFER_USAGE_GPU_FRAMEBUFFER;
30 }
31 if (desc.usage & static_cast<HardwareBufferUsage>(
32 HardwareBufferUsageFlags::kCompositorOverlay)) {
33 ahb_desc.usage |= AHARDWAREBUFFER_USAGE_COMPOSER_OVERLAY;
34 }
35 if (desc.usage & static_cast<HardwareBufferUsage>(
36 HardwareBufferUsageFlags::kSampledImage)) {
37 ahb_desc.usage |= AHARDWAREBUFFER_USAGE_GPU_SAMPLED_IMAGE;
38 }
39 return ahb_desc;
40 }

References impeller::android::HardwareBufferDescriptor::format, impeller::TSize< T >::height, kCompositorOverlay, kFrameBufferAttachment, kSampledImage, impeller::android::HardwareBufferDescriptor::size, ToAHardwareBufferFormat(), impeller::android::HardwareBufferDescriptor::usage, and impeller::TSize< T >::width.

Referenced by impeller::android::HardwareBufferDescriptor::IsAllocatable().

## ◆ ToAHardwareBufferFormat()

static AHardwareBuffer_Format impeller::android::ToAHardwareBufferFormat | ( | HardwareBufferFormat | format | ) |
| static

Definition at line 11 of file hardware_buffer.cc.

12 {
13 switch (format) {
14 case HardwareBufferFormat::kR8G8B8A8UNormInt:
15 return AHARDWAREBUFFER_FORMAT_R8G8B8A8_UNORM;
16 }
17 FML_UNREACHABLE();
18 }

References kR8G8B8A8UNormInt.

Referenced by ToAHardwareBufferDesc().

impeller::android::HardwareBufferUsage
uint8_t HardwareBufferUsage
Definition: hardware_buffer.h:29
impeller::android::HardwareBufferUsageFlags::kCompositorOverlay
@ kCompositorOverlay
impeller::PixelFormat::kR8G8B8A8UNormInt
@ kR8G8B8A8UNormInt
impeller::kSampledImage
@ kSampledImage
Definition: runtime_types.h:24
impeller::android::ToAHardwareBufferFormat
static AHardwareBuffer_Format ToAHardwareBufferFormat(HardwareBufferFormat format)
Definition: hardware_buffer.cc:11
impeller::android::GetProcTable
const ProcTable & GetProcTable()
Definition: proc_table.cc:12
impeller::android::HardwareBufferUsageFlags::kFrameBufferAttachment
@ kFrameBufferAttachment